	list p=16f88
	#include <p16f88.inc>
	radix dec

	errorlevel  -302 , -207 ; suppress message 302 from list file

	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

; Compiled with: PIC Simulator IDE v6.85
; Microcontroller model: PIC16F88
; Clock frequency: 4.0 MHz
;

;user regs
DelCnt0 EQU 0x20
DelCnt1 EQU 0x28
ledon EQU 0x2C
ledoff EQU 0x2D
adcv0 EQU 0x2E


	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO Start
	ORG 0x0004
	RETFIE


; Begin of program
Start:
; 2: AllDigital
	BSF STATUS,RP0
	CLRF ANSEL 
	MOVLW 0x07
	MOVWF CMCON

;adc set for 8 bit value 0 to 255
;5V=255 in ADRESH
; 11: Define ADC_CLOCK = 3
; 12: Define ADC_SAMPLEUS = 50 '50 microsec adc delay

; 14: ANSEL = 0x07 'a0,1,2... d3,4,5,6,7
	MOVLW 0x07
	MOVWF ANSEL;;0x9B;;;1B
; 15: TRISA = 0x1f 'an0,1,2... di3,d14,di5...do6,do7
	MOVLW 0x1F
	MOVWF PORTA
	BCF STATUS,RP0
 
; 17: ADCON0 = 0x40 'fsosc/8,chan0,/done,adc off
	MOVLW 0x40
	MOVWF ADCON0
; 18: ADCON1 = 0x00 'left justified ,avdd,avss,xxxx
	BSF STATUS,RP0
	CLRF ADCON1

; 21: TRISB = 0xf0 'bi0,1,2,3...bo4,5,6,7
	MOVLW 0xF0
	MOVWF PORTB
	BCF STATUS,RP0
 
; 23: ledon = 100 'hysteresis +1.97V LDR inp
	MOVLW 0x64
	MOVWF 0x2C
; 24: ledoff = 90 'LDR voltage + 1.77v
	MOVLW 0x5A
	MOVWF 0x2D
 

Loop:
; 29: Adcin 0, adcv0
	BSF STATUS,RP0	;bank1
	BCF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x00
	BCF STATUS,RP0	;bank0

	MOVWF DelCnt0
	CALL ReadAdc
	MOVF ADRESH,W
	MOVWF adcv0	;save ADRESH

; 32: If adcv0 < ledoff Then 'LDR lighter so LED off
	MOVF ledoff,W
	SUBWF adcv0,W
	BTFSC STATUS,C
	GOTO Skip1
; 33: PORTB.0 = 0
	BCF PORTB,0
; 34: Endif

Skip1:
 
; 36: If adcv0 > ledon Then 'LDR darker so LED on
	MOVF adcv0,W
	SUBWF ledon,W
	BTFSC STATUS,C
	GOTO Skip2
; 37: PORTB.0 = 1
	BSF PORTB,0
; 38: Endif

Skip2:
; 40: Goto loop
	GOTO Loop

; End of program


; Waitus Routine - Byte Argument
WaitUs:	MOVLW 0x0A
	SUBWF DelCnt1,F
	BTFSS STATUS,C
	RETURN
	GOTO X002

X002:	MOVLW 0x06
	SUBWF DelCnt1,F
	BTFSS STATUS,C
	RETURN
	GOTO X002

; Adcin Routine
ReadAdc:	
	RLF DelCnt0,F
	RLF DelCnt0,F
	RLF DelCnt0,F
	MOVLW 0x38
	ANDWF DelCnt0,F
	MOVLW 0xC1
	IORWF DelCnt0,W
	MOVWF ADCON0
	MOVLW 0x32
	MOVWF DelCnt1
	CALL WaitUs

	BSF ADCON0,GO	;adc on
A002:	BTFSC ADCON0,GO ;test for adc done
	GOTO A002
	BCF PIR1,ADIF	;clr adc IF
	BCF ADCON0,ADON ;adc off
	RETURN

; End of listing
	END
